unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes,
  SysUtils,
  Forms,
  Controls,
  Graphics,
  uDownload,
  //opensslsockets,
  Dialogs,
  StdCtrls,
  Laz.VirtualTrees;

type
  PData = ^TData;

  TData = record
    FUrl: String;
    FName: String;
    FState: String;
  end;


  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    VST: TVirtualStringTree;
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure VSTGetNodeDataSize(Sender: TBaseVirtualTree; var NodeDataSize: Integer);
    procedure VSTGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: String);
  private
    FDownload: TDownload;
    procedure DoOnDownloadProgress(Sender: TObject; {%H-}AFrom, ATo: String; APos, ASize, AElapsed, ARemaining, ASpeed: Longint);
    procedure DoOnDownloadCompleted(Sender: TObject);
  public

  end;

var
  Form1: TForm1;
  nro_descargas_total, nro_descarga_actual: integer;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  Data: Pdata;
  Node: PVirtualNode;
begin
  {nro_descargas_total:=0;
  nro_descarga_actual:=0;}

  VST.Clear;
  VST.NodeDataSize := SizeOf(TData);

  Node := VST.AddChild(nil);
  Data := VST.GetNodeData(Node);
  Data^.FUrl := 'https://www.rarlab.com/rar/winrar-x64-611es.exe?x-clickref=1101lwb9KLZk';
  Data^.FName := 'winrar.exe';
  Data^.FState := '';

  Node := VST.AddChild(nil);
  Data := VST.GetNodeData(Node);
  Data^.FUrl := 'https://download.mozilla.org/?product=firefox-latest&os=win64&lang=es-MX';
  Data^.FName := 'firefox.exe';
  Data^.FState := '';

  Node := VST.AddChild(nil);
  Data := VST.GetNodeData(Node);
  Data^.FUrl := 'https://mirror.netcologne.de/videolan.org/vlc/3.0.17.4/win64/vlc-3.0.17.4-win64.exe';
  Data^.FName := 'vlc.exe';
  Data^.FState := '';

  {Node := VST.AddChild(nil);
  Data := VST.GetNodeData(Node);
  Data^.FUrl := 'https://ardownload2.adobe.com/pub/adobe/acrobat/win/AcrobatDC/2200220191/AcroRdrDCx642200220191_MUI.exe';
  Data^.FName := 'adobe_reader.exe';
  Data^.FState := '';

  Node := VST.AddChild(nil);
  Data := VST.GetNodeData(Node);
  Data^.FUrl := 'https://www.avast.com/es-ww/download-thank-you.php?product=FAV-AVAST&locale=es-ww&direct=1';
  Data^.FName := 'avast.exe';
  Data^.FState := '';

  Node := VST.AddChild(nil);
  Data := VST.GetNodeData(Node);
  Data^.FUrl := 'https://mirrors.ucr.ac.cr/tdf/libreoffice/stable/7.4.1/win/x86_64/LibreOffice_7.4.1_Win_x64.msi';
  Data^.FName := 'libre_office.msi';
  Data^.FState := '';

  Node := VST.AddChild(nil);
  Data := VST.GetNodeData(Node);
  Data^.FUrl := 'https://data-cdn.mbamupdates.com/web/mb4-setup-consumer/offline/mb4-setup-consumer-4.5.14.210-1.0.1751-1.0.59171.exe';
  Data^.FName := 'malwarebytes.exe';
  Data^.FState := ''; }

  FDownload := nil;

end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if Assigned(FDownload) then
    FDownload.CancelDownoad;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  node: PVirtualNode;
  Data: PData;
begin
  // ShowMessage(ExtractFilePath(Application.ExeName));
  nro_descargas_total:=0;
  nro_descarga_actual:=0;

  node := VST.GetFirst;
  while assigned(node) do
  begin
    Data := VST.GetNodeData(Node);

      {
      ShowMessage(Data^.FUrl);
      ShowMessage(Data^.FName);
      ShowMessage(Data^.FState);
      }

    nro_descargas_total:=nro_descargas_total+1;
    Data^.FState := 'downloading';
    FDownload := TDownload.Create;
    FDownload.OnDownloadProgress := @DoOnDownloadProgress;
    FDownload.OnDownloadCompleted := @DoOnDownloadCompleted;
    FDownload.DownloadFile(Data^.FUrl, ExtractFilePath(Application.ExeName) + Data^.FName);


    node := VST.GetNext(node);
  end;
  vst.SetFocus;
  vst.Refresh;
end;

procedure TForm1.VSTGetNodeDataSize(Sender: TBaseVirtualTree; var NodeDataSize: Integer);
begin
  NodeDataSize := SizeOf(TData);
end;

procedure TForm1.VSTGetText(Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; var CellText: String);
var
  Data: PData;
begin
  // si no existen estos codes, el resultado sera el texto    "NODE"
  Data := VST.GetNodeData(Node);
  case Column of
    0: CellText := Data^.FUrl;
    1: CellText := Data^.FName;
    2: CellText := Data^.FState;
  end;
end;

procedure TForm1.DoOnDownloadProgress(Sender: TObject; AFrom, ATo: String; APos, ASize, AElapsed, ARemaining, ASpeed: Longint);
var
  node: PVirtualNode;
  Data: PData;
begin
  node := VST.GetFirst;
  while assigned(node) do
  begin
    Data := VST.GetNodeData(Node);

    if TDownload(Sender).OriginalURL = Data^.FUrl then
    begin

    {  // trabaja bien
    if ASize > 0 then
    Data^.FState := 'Received: ' + '  ' + FormatSize(APos) + ' / ' + FormatSize(ASize)
    else
    Data^.FState := 'Received: ' + '  ' + FormatSize(APos) + ' / ' + 'Unknown';
    }

    if ASize > 0 then
    begin
    Data^.FState :='Downloading '+inttostr(Round((APos/ASize) * 100))+'%';
    //vst.Refresh;
    end;

      //Data^.FState := Format('downloading (%f %%)', [APos * 100 / ASize]);  // original
      vst.InvalidateNode(node);
      //vst.Refresh;
      break;
    end
    else
      node := VST.GetNext(node);
  end;
end;

procedure TForm1.DoOnDownloadCompleted(Sender: TObject);
var
  node: PVirtualNode;
  Data: PData;
begin
  node := VST.GetFirst;
  while assigned(node) do
  begin
    Data := VST.GetNodeData(Node);

    if TDownload(Sender).OriginalURL = Data^.FUrl then
    begin
    nro_descarga_actual:=nro_descarga_actual+1;
      Data^.FState := 'downloaded';
      vst.InvalidateNode(node);
      //vst.Refresh;
      break;
    end
    else
      node := VST.GetNext(node);
  end;
  if nro_descarga_actual=nro_descargas_total then ShowMessage('TODAS LAS DESCARGAS FINALIZADAS');
end;



end.
